#!/usr/local/bin/perl

# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
# SPPDレンタルサーバー フォームメールCGI Ver1.15 メイン画面
# (C) 2004-2017 Playing Network ,INC. All Rights Reserved.
# Programmed By Yasushi Toguchi
# 
# 著作権は株式会社プレイングネットワークに帰属します。
#
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

sub default
{
	print "Content-type: text/html\n\n";

	my($layout) = $template_files."default.html";

	# ●メールログ一覧
	opendir (DIR,"$LogDir");
	@LogList = sort grep (/^\d+\.(log|txt)$/ && -f "$LogDir"."$_",readdir (DIR));
	closedir (DIR);
	$LogList=scalar(@LogList);

	# ●ダウンロードしてないログの件数
	$midoku = grep(/\.log$/,@LogList);

	# ●開始年月と終了年月
	my $year1 = substr($LogList[0], 0, 4);
	my $mon1 = substr($LogList[0], 4, 2);
	my $day1 = substr($LogList[0], 6, 2);
	my $year2 = substr($LogList[$#LogList], 0, 4);
	my $mon2 = substr($LogList[$#LogList], 4, 2);
	my $day2 = substr($LogList[$#LogList], 6, 2);

	# ●その他設定
	$Subject =~ s/"/&quot;/g;
	$Subject =~ s/</&lt;/g;
	$Subject =~ s/>/&gt;/g;
	$MailTo =~ s/"/&quot;/g;
	$MailTo =~ s/</&lt;/g;
	$MailTo =~ s/>/&gt;/g;
	if($url{complete})
	{
		$Message = '設定変更が完了しました。';
	}
	elsif($url{changed})
	{
		$Message = 'パスワードを変更しました。';
	}
	elsif($url{deleted})
	{
		$Message = 'ログの削除が完了しました。';
	}


	# ●表示開始
	open(TEMPLATE,"$layout");
	foreach(<TEMPLATE>)
	{
		if(/(.*)(\%LogSave\%)(.*)/)
		{
			# ●ログ保存
			print $1;
			print '<option value="0">ログを保存しない'."\n";
			if($LogSave == 1)
			{
				print '<option value="1" selected>ログを保存する'."\n";
			}
			else
			{
				print '<option value="1">ログを保存する'."\n";
			}
			print $3;
			
		}
		elsif(/(.*)(\%Confirm\%)(.*)/)
		{
			# ●確認画面
			print $1;
			print '<option value="0">確認画面を表示しない'."\n";
			if($Confirm == 1)
			{
				print '<option value="1" selected>確認画面を表示する'."\n";
			}
			else
			{
				print '<option value="1">確認画面を表示する'."\n";
			}
			print $3;
		}
		elsif(/(.*)(\%s_year\%)(.*)/)
		{
			# ●開始年
			print $1;
			if(@LogList > 0)
			{
				for($i=$year1;$i<=$year2;$i++)
				{
					$i==$year1 ? print "<option value=\"$i\" selected>$i\n" : print "<option value=\"$i\">$i\n";
				}
			}
			print $3;
		}
		elsif(/(.*)(\%s_mon\%)(.*)/)
		{
			# ●開始月
			print $1;
			for($i=1;$i<=12;$i++)
			{
				$i==$mon1 ? printf "<option value=\"%02d\" selected>%02d\n",$i,$i : printf "<option value=\"%02d\">%02d\n",$i,$i;
			}
			print $3;
		}
		elsif(/(.*)(\%s_day\%)(.*)/)
		{
			# ●開始日
			print $1;
			for($i=1;$i<=31;$i++)
			{
				$i==$day1 ? printf "<option value=\"%02d\" selected>%02d\n",$i,$i : printf "<option value=\"%02d\">%02d\n",$i,$i;
			}
			print $3;
		}
		elsif(/(.*)(\%e_year\%)(.*)/)
		{
			# ●終了年
			print $1;
			if(@LogList > 0)
			{
				for($i=$year1;$i<=$year2;$i++)
				{
					$i==$year2 ? print "<option value=\"$i\" selected>$i\n" : print "<option value=\"$i\">$i\n";
				}
			}
			print $3;
		}
		elsif(/(.*)(\%e_mon\%)(.*)/)
		{
			# ●終了月
			print $1;
			for($i=1;$i<=12;$i++)
			{
				$i==$mon2 ? printf "<option value=\"%02d\" selected>%02d\n",$i,$i : printf "<option value=\"%02d\">%02d\n",$i,$i;
			}
			print $3;
		}
		elsif(/(.*)(\%e_day\%)(.*)/)
		{
			# ●終了日
			print $1;
			for($i=1;$i<=31;$i++)
			{
				$i==$day2 ? printf "<option value=\"%02d\" selected>%02d\n",$i,$i : printf "<option value=\"%02d\">%02d\n",$i,$i;
			}
			print $3;
		}
		elsif(/\%.+\%/)
		{
			# ●その他
			s/\%LogDir\%/$LogDir/g;
			s/\%MailTo\%/$MailTo/g;
			s/\%Subject\%/$Subject/g;
			s/\%TOTAL_LOG\%/$LogList/g;
			s/\%MIDOKU_LOG\%/$midoku/g;
			s/\%Necessary\%/$Necessary/g;
			s/\%CompletePage\%/$CompletePage/g;
			s/\%MESSAGE\%/$Message/g;
			### Ver1.12 --<toguchi START
			s/\%URLINVALID0\%/($UrlInvalid ? "" : "selected")/eg;
			s/\%URLINVALID1\%/($UrlInvalid ? "selected" : "")/eg;
			### Ver1.12 --<toguchi END
			print;
		}
		else
		{
			print;
		}
	}
	close(TEMPLATE);
}
1