#!/usr/local/bin/perl

# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
#
# SPPDレンタルサーバー フォームメールCGI Ver1.15 (UTF-8 Ver 1.0)
# (C) 2004-2017 Playing Network ,INC. All Rights Reserved.
# Programmed By Yasushi Toguchi/Toshikazu Sugama
# 
# フォームメールスクリプトは[SPPDレンタルサーバー]のご契約者様が
# SPPDレンタルサーバーでホスティングされているサーバースペースに
# アップロードし、利用する用途でのみ複製可能です。
# 外部のサーバーへのアップロードは許諾しておりません。
# スクリプトを改変された場合はサポート対象外とさせて頂きます。
#
# 著作権は株式会社プレイングネットワークに帰属します。
#
# -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

#------------------------#
# ■設定ファイル読み込み #
#------------------------#
require "./admin/ini.cgi";

#----------#
# ■初期化 #
#----------#
undef(@Names);
undef(@Values);
$template_files = "./template/";

### Ver1.12 --<toguchi START
#-----------------------#
# ■URLデータを受け取る #
#-----------------------#
foreach $i (split('&',$ENV{'QUERY_STRING'})) {
	my ($variable,$value)=split('=',$i);
	$variable=~ tr/+/ /;
	$variable=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
	$value=~ tr/+/ /;
	$value=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
	$get{$variable} = $value;
}
### Ver1.12 --<toguchi END

#--------------------------------#
# ■フォームからデータを受け取る #
#--------------------------------#
if ($ENV{'REQUEST_METHOD'} eq "POST")
{
	read (STDIN,$str,$ENV{'CONTENT_LENGTH'});
	@part=split('&',$str);
	foreach $i (@part)
	{
		($variable,$value)=split('=',$i);
		$variable=~ tr/+/ /;
		$variable=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
		$value=~ tr/+/ /;
		$value=~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
		$value=~ s/"/”/g;
		$value=~ s/,/，/g;
		$value=~ s/=/＝/g;
		$value=~ s/</\&lt;/g;
		$value=~ s/>/\&gt;/g;
		$value=~ s/\015\012/<br>/g;
		$value=~ s/\012/<br>/g;
		$value=~ s/\015/<br>/g;
		push(@Names,"$variable");
		push(@Values,"$value");
		$form{$variable} = $value;
	}
}
### Ver1.11 --<Sugama
else {
	&ErrorMessage('GETメソッドによる不正なアクセスです。');
}
### Ver1.11 -->Sugama

#--------------------------------#
# ■メールアドレスの書式チェック #
#--------------------------------#
if($MailTo !~ /^.+\@.+\.[A-Za-z]+$/)
{
	&ErrorMessage('管理者画面の「メール送信先」の設定が空欄になっているか、または、メールアドレスとして使用できない文字が使われています。<br>管理画面にアクセスして、「メール送信先」を正しく設定してください。');
}

if($Necessary ne "" && $form{'MailFrom'} !~ /^.+\@.+\.[A-Za-z]+$/)
{
	&ErrorMessage('「メールアドレス」が未記入、または書式が間違っていますので送信できません。<BR>***@***.*** の形式で記入してください');
}

### Ver1.12 --<toguchi START
#-------------------------------#
# ■URL入力禁止の場合はチェック #
#-------------------------------#
if($UrlInvalid) {
	foreach(keys(%form)) {
		&ErrorMessage('URLの入力は禁止されています') if($form{$_} =~ /https?:\/\//);
	}
}
### Ver1.12 --<toguchi END

### Ver1.12 --<toguchi START
#--------------------#
# ■必須項目チェック #
#--------------------#
foreach(keys(%form)) {
	if(/^(.+)_sppdhissu$/ && $form{$1} eq "") {
		&ErrorMessage('必須項目が入力されていません')
	}
}
### Ver1.12 --<toguchi END


#--------------------------#
# ■fromが不正な場合は     #
#   管理者のアドレスに変更 #
#--------------------------#
if($form{'MailFrom'} !~ /^.+\@.+\.[A-Za-z]+$/) {
	$form{'MailFrom'} = $MailTo;
}


#----------------------#
# ■確認画面がある場合 #
#----------------------#

###if($Confirm == 1 && $ENV{'HTTP_REFERER'} !~ /^(http|https):\/\/$ENV{'HTTP_HOST'}$ENV{'REQUEST_URI'}$/)
#if($Confirm == 1 && $form{'confirm'} ne "1" ) 
if($Confirm == 1 && $get{'confirm'} ne "1" ) 
{
	print "Content-type: text/html\n\n";
	open(CONFIRM,$template_files."confirm.html");
	while(<CONFIRM>)
	{
#		s/\%SCRIPT_NAME\%/$ENV{'SCRIPT_NAME'}/g;
		s/\%SCRIPT_NAME\%/$ENV{'SCRIPT_NAME'}\?confirm=1/g;

		if(/(.*)(\%CONFIRM_LIST\%)(.*)/)
		{
			print $1;
			for($x=0;$x<scalar(@Names);$x++)
			{
				### Ver1.12 --<toguchi START
				next if($Names[$x] =~ /.+_sppdhissu$/);
				### Ver1.12 --<toguchi END
				open (SUB,$template_files."confirm_table.html");
				while (<SUB>)
				{
					s/\%name\%/$Names[$x]/g;
					s/\%value\%/$Values[$x]/g;
					print;
				}
				close(SUB);
			}
			print $3;
		}
		else
		{
			print;
		}
	}
	close(CONFIRM);
}

else
{
	#-------------------------------------------------------#
	# ■メール送信                                          #
	#   ログ保存する設定の場合はログ保存してからメール送信  #
	#   ※ディレクトリが存在しないと無効                    #
	#-------------------------------------------------------#

	use MIME::Base64;

	if($LogSave==1 && -d $LogDir)
	{
		while(!($WriteFile))
		{
			if($tmp > 10)
			{
				&ErrorMessage('現在サーバーが混雑状態の為、送信できませんでした。');
			}

			# 日付取得
			(@dates) = localtime(time);
			$dates[4]++;
			$dates[5]=$dates[5]+1900;
			$dates[4] = sprintf("%02d",$dates[4]);
			$dates[3] = sprintf("%02d",$dates[3]);
			$dates[2] = sprintf("%02d",$dates[2]);
			$dates[1] = sprintf("%02d",$dates[1]);
			$dates[0] = sprintf("%02d",$dates[0]);

			if(-e "$LogDir".$dates[5].$dates[4].$dates[3].$dates[2].$dates[1].$dates[0].'.log')
			{
				$tmp++;
			}
			else
			{
				$WriteFile = "$LogDir".$dates[5].$dates[4].$dates[3].$dates[2].$dates[1].$dates[0].'.log';
				$TempFile  = "$LogDir".$$.'.tmp';
			}
		}

		open(WRITE,">$TempFile");
		print WRITE "$dates[5]/$dates[4]/$dates[3]\n";
		print WRITE "$dates[2]:$dates[1]:$dates[0]\n";
		print WRITE "Subject=$Subject\n";
		for($x=0;$x<scalar(@Names);$x++)
		{
			### Ver1.12 --<toguchi START
			next if($Names[$x] =~ /.+_sppdhissu$/);
			### Ver1.12 --<toguchi END

			$Values[$x] =~ s/&lt;/</g;
			$Values[$x] =~ s/&gt;/>/g;
			print WRITE $Names[$x]."=".$Values[$x]."\n";
		}
		close(WRITE);
		rename ($TempFile,$WriteFile);
		chmod 0606, $WriteFile;
	}

	#--------------#
	# ★メール送信 #
	#--------------#

	$sendmail="/usr/lib/sendmail";
	$Subject = encode_base64($Subject);
	$Subject =~ s/\n//g;
	my $mbody = "";

	open (MAIL ,"| $sendmail -t -i");
	print MAIL "From: $form{MailFrom}\n";
	print MAIL "To: $MailTo\n";
	print MAIL "Subject: =?utf-8?B?$Subject?=\n";
	print MAIL "MIME-Version: 1.0\n";
	print MAIL "Content-Type: text/plain; charset=\"utf-8\"\n";
	print MAIL "Content-Transfer-Encoding: base64\n\n";

	for($x=0;$x<scalar(@Names);$x++)
	{
		### Ver1.12 --<toguchi START
		next if($Names[$x] =~ /.+_sppdhissu$/);
		### Ver1.12 --<toguchi END

		$Values[$x] =~ s/<br>/\n/ig;

		## 20050901
		$Values[$x] =~ s/&gt;/>/ig;
		$Values[$x] =~ s/&lt;/</ig;
		## -20050901
		$mbody .= "[$Names[$x]]\n$Values[$x]\n\n";
	}
	print MAIL encode_base64($mbody);
	close(MAIL);

	#----------------------#
	# ★メール送信完了画面 #
	#----------------------#
	print "Location: $CompletePage\n\n";

}
exit;

# ■エラーメッセージ表示
sub ErrorMessage
{
	print "Content-type: text/html\n\n";

	my($Message) = @_[0];
	open(ERROR,$template_files."error.html");
	while(<ERROR>)
	{
		s/\%ERROR_MESSAGE\%/$Message/g;
		print;
	}
	close(ERROR);
	exit;
}
